 // stdoutdemo - stdout & clock() test, V1.0 'Lazycow 2020
// disclaimer: This is C code, not a C tutorial.

#include <stdio.h>
#include <time.h>


// const is mandatory here to place texts in ROM
const char* const tTab[]={
	"\n   **** VBCC STDOUT DEMO ****\n\n",
	" 2K RAM SYSTEM  1280 BYTES FREE\n\n",
	"2READY.\n",
	"#the quir<ck brown fog<x jumpd<s over\n",
	"#the lazy cow<<<dog\n",
	"\n?FORMULA TOO COMPLEX  ERROR!\n",
	"2READY.\n",
	"#Big endg<ian is the p<one and only\n",
	"#correct v<bytr<e order!\n",
	"\n?UNDEFINED STATEMENT  ERROR!\n",
	"2READY.\n",
	"#10 for i=0 to 19\n",
	"#20 print tab(i)\"hello world!\"\n",
	"2#30 next:goto 10\n",
	"#run\n",
	"hello world!\n",
	" hello world!\n",
	"  hello world!\n",
	"   hello world!\n",
	"    hello world!\n",
	"     hello world!\n",
	"      hello world!\n",
	"       hello world!\n",
	"        hello world!\n",
	"         hello world!\n",
	"          hello world!\n",
	"           hello world!\n",
	"            hello world!\n",
	"             hello world!\n",
	"              hello world!\n",
	"               hello world!\n",
	"                hello world!\n",
	"                 hello world!\n",
	"                  hello world!\n",
	"                   hello world!\n",
	"hello world!\n",
	" hello world!\n",
	"  hello world!\n",
	"   hello world!\n",
	"    hello world!\n",
	"     hello world!\n",
	"      hello world!\n",
	"       hello world!\n",
	"        hello world!\n",
	"         hello world!\n",
	"          hello world!\n",
	"           hello world!\n",
	"            hello world!\n",
	"             hello world!\n",
	"              hello world!\n",
	"               hello world!\n",
	"                hello world!\n",
	"                 hello world!\n",
	"                  hello world!\n",
	"                   hello world!\n",
	"BREAK IN 20\n",
	"4READY.\n",
	"\n",
	"#  (__)\n",
	"#  (--)\n",
	"#   \\/--\n",
	"#    |\n",
	"\n?LAZYCOW  ERROR!\n",
	"READY.\n",
	NULL
};

#define MIRRORING ((unsigned char*)0xA000)

 //
//
int main() {
	const unsigned char dTab[]={2,1,4,2,2,1,2,3,4,4,2,3,1,2,4,2}; // typing delays
	const char* p;  unsigned char i, dTabOff=0;
	clock_t t, l=clock();
	char line[32+1+1];  line[0]='\r'; // growing line buffer

  *MIRRORING=0; // vbcc's stdout currently only support vertical mirroring

	for (i=0;p=tTab[i];++i) {
		unsigned char x, y, waitCounter=0, typeMode=0;

		// parse special commands
		if ('1'<=p[0] && p[0]<='9') { waitCounter=p[0]-'0';  ++p; } // delay?
		if ('#'==p[0]) { typeMode=1;  ++p; } // type?
		// type?
		if (typeMode) for (x=0,y=1;p[x];++x,++y) {
			clock_t tics=CLOCKS_PER_SEC;  tics>>=dTab[dTabOff++];  dTabOff&=15;
			if ('<'==p[x] && y>=2) y-=2; else line[y]=p[x]; // del or type?
			line[y+1]='\0';  printf("%s",line); // write part of growing line
			fflush(stdout); // <-- only needed on systems with linebuffer (Linux)
			for (;;) if ((t=clock())-l>=tics) { l=t;  break; } // busy-wait
		} else printf("%s",p);

		// wait?
		if (waitCounter) for (;;) if ((t=clock())-l>=CLOCKS_PER_SEC)
			{ l=t;  if (--waitCounter==0) break; }
	}
	return 0;
}
